;;; dired-do-emacs-command.el --- Just like ! (dired-do-shell-command).

;; INSTALL: Just load from your loadpath.

;; copyright (c) 2000 S.Namba <sn@asahi-net.email.ne.jp>
;;                    http://www.asahi-net.or.jp/~pi9s-nnb
;; free software, no warranty.

;; Example:
;; On "index.html" line in `dired' buffer, hit
;;    \ w3-open-local RET
;; opens the HTML file with `w3-open-local' command, or
;; on "Hammerklavier.mp3", "ringo.m3u", or on directory "mp3files" line,
;;    \ mpg123
;; fires up mpg123.

;; --- Actually, invokes non-interactive functions (for experts).
;; Change "a" to "C" in interactive() arg string.

;; Tue Nov 14 10:01:31 2000

(require 'dired)

(define-key dired-mode-map "\\" 'dired-do-emacs-command)

;; `fun' may be non-interactive function
(defun dired-do-emacs-fun-one (fname fun)
  "Passin FNAME as an argument,  call FUN."
  (interactive "fWhat file: \naWhat emacs function: ")
  (funcall fun fname))

(defun dired-do-emacs-command (com arg)
  "Run emacs `command' or `function' over filenames generated by \
`dired-get-marked-files'."
  (interactive "aWhat emacs command: \nP")
  (let ((fn-list (dired-get-marked-files nil arg)))
    (mapcar
     (lambda (fn)
       (dired-do-emacs-fun-one fn com)) fn-list)))

(provide 'dired-do-emacs-command)
